// =========================================================
// Просмотр содержимого каталога при помощи класса File 
//
// (C) Фролов А.В, 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            или
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.io.*;
import java.util.*;

// =========================================================
// Класс DirList
// Главный класс приложения
// =========================================================
public class DirList
{
  // -------------------------------------------------------
  // main
  // Метод, получающий управление при запуске приложения
  // -------------------------------------------------------
  public static void main(String args[])
  {
    // Массив для ввода строки с клавиатуры
    byte bKbdInput[] = new byte[256];

    // Путь к каталогу, содержимое которого
    // мы будем просматривать
    String sDirPath;

    // Маска для просмотра
    String sMask;

    // Массив строк содержимого каталога
    String[] dirlist;

    try
    {
      // Выводим строку приглашения для ввода пути
      // к каталогу, содержимое которого будем просматривать
      System.out.println("Enter directory path...");
      System.in.read(bKbdInput);
      sDirPath = new String(bKbdInput, 0);
      StringTokenizer st;
      st = new StringTokenizer(sDirPath, "\r\n");
      sDirPath = new String((String)st.nextElement());

      // Вводим строку маски
      System.out.println("Enter mask...");
      System.in.read(bKbdInput);
      sMask = new String(bKbdInput, 0);
      st = new StringTokenizer(sMask, "\r\n");
      sMask = new String((String)st.nextElement());
      
      // Создаем объект класса File, соответствующий
      // введенному пути
      File fdir = new File(sDirPath);

      // Если указанный каталог не существует,
      // выводим сообщение и завершаем работу
      if(!fdir.exists())
      {      
        System.out.println("Directory not found: " + sDirPath);
      }
      
      // Если путь существует, определяем параметры
      // соответствующего файла или каталога
      else
      {
        // Проверяем, был указан файл или каталог
        if(!fdir.isDirectory())
          System.out.println("File " + sDirPath + 
            " is not directory");

        // Если указан каталог, получаем его содержимое
        else
        {
          // Если маска не задана, вызываем метод list
          // без параметров
          if(sMask == null)
            dirlist = fdir.list();
          
          // Вызываем метод list, создавая фильтр
          else
            dirlist = fdir.list(new MaskFilter(sMask));

          // Сканируем полученный массив
          for (int i = 0; i < dirlist.length; i++)
          {
            // Для каждого объекта, обнаруженного в каталоге,
            // создаем объект класса File
            File f = new File(sDirPath + "\\" + dirlist[i]);
            
            // Имена файлов отображаем строчными буквами
            if(f.isFile())
              System.out.println(dirlist[i].toLowerCase());
            
            // Имена каталогов оставляем без изменения
            else
              System.out.println(dirlist[i]);
          }
        }
      }

      System.out.println("Press <Enter> to terminate...");
      System.in.read(bKbdInput);
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }
}

// =========================================================
// Класс MaskFilter
// Фильтр для просмотра каталога
// =========================================================
class MaskFilter implements FilenameFilter
{
  // Поле для хранения маски имени
  String sNameMask;

  // -------------------------------------------------------
  // Конструктор класса MaskFilter
  // Сохраняет маску фильтра
  // -------------------------------------------------------
  MaskFilter(String sMask)
  {
    // Записываем маску прописными буквами
    sNameMask = sMask.toUpperCase();
  }

  // -------------------------------------------------------
  // Метод accept
  // Проверка имени по маске
  // -------------------------------------------------------
  public boolean accept(File dir, String name)
  {
    // Если маска указана как символ *, подходит любое имя
    if(sNameMask.equals("*"))
      return true;

    // Если имя содержит маску, возвращаем значение true
    return (name.indexOf(sNameMask) != -1);
  }
}
